"use strict";
exports.__esModule = true;
var types = require("@babel/types");
var nej_inject_type_enum_1 = require("../parser/enums/nej-inject-type.enum");
function generatorNejInjects(nejInjects) {
    return nejInjects.map(function (_a) {
        var type = _a.type, alias = _a.alias;
        var statement;
        switch (type) {
            case nej_inject_type_enum_1.NejInjectType.array:
                statement = types.variableDeclaration('var', [
                    types.variableDeclarator(types.identifier(alias), types.arrayExpression())
                ]);
                break;
            case nej_inject_type_enum_1.NejInjectType["function"]:
                statement = types.variableDeclaration('var', [
                    types.variableDeclarator(types.identifier(alias), types.functionExpression(null, [], types.blockStatement([])))
                ]);
                break;
            case nej_inject_type_enum_1.NejInjectType.object:
                statement = types.variableDeclaration('var', [
                    types.variableDeclarator(types.identifier(alias), types.objectExpression([]))
                ]);
                break;
            default:
                statement = types.variableDeclaration('var', [
                    types.variableDeclarator(types.identifier(alias))
                ]);
        }
        return statement;
    });
}
exports.generatorNejInjects = generatorNejInjects;
//# sourceMappingURL=generator-nej-injects.js.map