"use strict";
exports.__esModule = true;
var types = require("@babel/types");
var nej_inject_type_enum_1 = require("./enums/nej-inject-type.enum");
var parser_util_1 = require("./parser.util");
function nejCodeParser(path, options) {
    var fnBody;
    var dependencies = [];
    var nejInject = [];
    var nejInjectType = [
        nej_inject_type_enum_1.NejInjectType.object,
        nej_inject_type_enum_1.NejInjectType.object,
        nej_inject_type_enum_1.NejInjectType["function"],
        nej_inject_type_enum_1.NejInjectType.array
    ];
    var visitor = {
        CallExpression: function (path) {
            var node = path.node;
            if (parser_util_1.checkIsDefineFunction(path)) {
                var _a = node.arguments, depArguments = _a[0], funExpression = _a[1];
                if (types.isFunctionExpression(depArguments)) {
                    funExpression = depArguments;
                    depArguments = types.arrayExpression([]);
                }
                var deps_1 = depArguments.elements.map(function (argument) { return argument.value; });
                var depLength_1 = deps_1.length;
                // 解析依赖和 nej 注入变量
                funExpression.params.map(function (param, index) {
                    if (index < depLength_1) {
                        dependencies.push(parser_util_1.analyzeDependence(deps_1[index], param.name, options));
                    }
                    else {
                        nejInject.push({
                            type: nejInjectType[index - depLength_1],
                            alias: param.name
                        });
                    }
                });
                // 解析函数主体
                fnBody = funExpression.body.body;
            }
        }
    };
    path.traverse(visitor);
    return {
        fnBody: fnBody,
        dependencies: dependencies,
        nejInject: nejInject
    };
}
exports.nejCodeParser = nejCodeParser;
//# sourceMappingURL=nej-code-parser.js.map