"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _this = this;
exports.__esModule = true;
var test_util_1 = require("../test.util");
var nej_inject_type_enum_1 = require("./enums/nej-inject-type.enum");
var nej_code_parser_1 = require("./nej-code-parser");
describe('nejParser', function () {
    it('nejParser is function', function () {
        expect(nej_code_parser_1.nejCodeParser).toBeInstanceOf(Function);
    });
    it('解析非 js 文件时, 返回 {fnBody: undefined, dependence: [], nejInject: []}', function () { return __awaiter(_this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, expect(test_util_1.getNejParseResult("111111")).resolves.toEqual({
                        fnBody: undefined,
                        dependencies: [],
                        nejInject: []
                    })];
                case 1:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    }); });
    it('正确解析主体函数', function () { return __awaiter(_this, void 0, void 0, function () {
        var code, fnBody;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    code = "\n            define(['base/util', './global', '{platform}element.js'], function() {\n                var _p = {};\n                \n                return _p;\n            })\n        ";
                    return [4 /*yield*/, test_util_1.getNejParseResult(code)];
                case 1:
                    fnBody = (_a.sent()).fnBody;
                    expect(fnBody.length).toEqual(2);
                    expect(fnBody[0].type).toEqual('VariableDeclaration');
                    expect(fnBody[1].type).toEqual('ReturnStatement');
                    return [2 /*return*/];
            }
        });
    }); });
    it('正确解析依赖', function () { return __awaiter(_this, void 0, void 0, function () {
        var code, _a, dependencies, nejInject;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    code = "\n            define(['base/util', './global.js', '{platform}element.js'], function(_util, _global, _element, _p, _o, _f, _r) {\n                var _p = {};\n                \n                return _p;\n            })\n        ";
                    return [4 /*yield*/, test_util_1.getNejParseResult(code)];
                case 1:
                    _a = _b.sent(), dependencies = _a.dependencies, nejInject = _a.nejInject;
                    expect(nejInject).toEqual([
                        { alias: '_p', type: nej_inject_type_enum_1.NejInjectType.object },
                        { alias: '_o', type: nej_inject_type_enum_1.NejInjectType.object },
                        { alias: '_f', type: nej_inject_type_enum_1.NejInjectType["function"] },
                        { alias: '_r', type: nej_inject_type_enum_1.NejInjectType.array }
                    ]);
                    expect(dependencies).toEqual([
                        {
                            'moduleType': 'javascript',
                            'name': '_util',
                            'rawSource': 'base/util',
                            'source': 'base/util.js'
                        },
                        {
                            'moduleType': 'javascript',
                            'name': '_global',
                            'rawSource': './global.js',
                            'source': './global.js'
                        },
                        {
                            'moduleType': 'javascript',
                            'name': '_element',
                            'rawSource': '{platform}element.js',
                            'source': 'platform/element.js'
                        }
                    ]);
                    return [2 /*return*/];
            }
        });
    }); });
    it('支持 NEJ.define()', function () { return __awaiter(_this, void 0, void 0, function () {
        var code, _a, dependencies, nejInject;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    code = "\n            NEJ.define(['base/util', './global.js', '{platform}element.js'], function(_util, _global, _element, _p, _o, _f, _r) {\n                var _p = {};\n                \n                return _p;\n            })\n        ";
                    return [4 /*yield*/, test_util_1.getNejParseResult(code)];
                case 1:
                    _a = _b.sent(), dependencies = _a.dependencies, nejInject = _a.nejInject;
                    expect(nejInject).toEqual([
                        { alias: '_p', type: nej_inject_type_enum_1.NejInjectType.object },
                        { alias: '_o', type: nej_inject_type_enum_1.NejInjectType.object },
                        { alias: '_f', type: nej_inject_type_enum_1.NejInjectType["function"] },
                        { alias: '_r', type: nej_inject_type_enum_1.NejInjectType.array }
                    ]);
                    expect(dependencies).toEqual([
                        {
                            'moduleType': 'javascript',
                            'name': '_util',
                            'rawSource': 'base/util',
                            'source': 'base/util.js'
                        },
                        {
                            'moduleType': 'javascript',
                            'name': '_global',
                            'rawSource': './global.js',
                            'source': './global.js'
                        },
                        {
                            'moduleType': 'javascript',
                            'name': '_element',
                            'rawSource': '{platform}element.js',
                            'source': 'platform/element.js'
                        }
                    ]);
                    return [2 /*return*/];
            }
        });
    }); });
    it('支持非 js 文件的解析', function () { return __awaiter(_this, void 0, void 0, function () {
        var code, dependencies;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    code = "\n            define(['text!./template.html', 'text!./style.css', 'regular!./tpl.html', 'json!./tpl.json'], function(t1, style, t2, data) {\n                var _p = {};\n                \n                return _p;\n            })\n        ";
                    return [4 /*yield*/, test_util_1.getNejParseResult(code)];
                case 1:
                    dependencies = (_a.sent()).dependencies;
                    expect(dependencies).toEqual([
                        {
                            'moduleType': 'text',
                            'name': 't1',
                            'rawSource': 'text!./template.html',
                            'source': './template.html'
                        },
                        {
                            'moduleType': 'text',
                            'name': 'style',
                            'rawSource': 'text!./style.css',
                            'source': './style.css'
                        },
                        {
                            'moduleType': 'regular',
                            'name': 't2',
                            'rawSource': 'regular!./tpl.html',
                            'source': './tpl.html'
                        },
                        {
                            'moduleType': 'json',
                            'name': 'data',
                            'rawSource': 'json!./tpl.json',
                            'source': './tpl.json'
                        }
                    ]);
                    return [2 /*return*/];
            }
        });
    }); });
});
//# sourceMappingURL=nej-code-parser.spec.js.map