import { NodePath } from '@babel/traverse';
import { CallExpression } from '@babel/types';
import { Options } from '../options.interface';
import { Dependence } from './interfaces/dependence.interface';
import { NejModuleType } from './interfaces/nej-module-type.interface';
/**
 * 检测是否是 NEJ.define 函数
 * @param {NodePath<CallExpression>} path
 * @return {boolean}
 */
export declare function checkIsDefineFunction(path: NodePath<CallExpression>): boolean;
/**
 * 分离依赖中的类型和路径
 *
 * @param {string} source
 */
export declare function splitModuleType(source: string): [NejModuleType, string];
/**
 * 标准化路径, 去掉其中的 alias 和 "{}"
 *
 * @param {string} source
 * @param options
 */
export declare function normalize(source: string, options: Options): string;
/**
 * 分析依赖信息
 *
 * @param {string} rawSource
 * @param {string} name
 * @param options
 * @return {Dependence}
 */
export declare function analyzeDependence(rawSource: string, name: string, options: Options): Dependence;
