"use strict";
exports.__esModule = true;
var generator_1 = require("@babel/generator");
var parser = require("@babel/parser");
var traverse_1 = require("@babel/traverse");
var nej_code_parser_1 = require("./parser/nej-code-parser");
function getNejParseResult(code) {
    return new Promise(function (resolve) {
        var ast = parser.parse(code);
        var options = {
            alias: {},
            isNejCode: true
        };
        traverse_1["default"](ast, {
            enter: function (path) {
                resolve(nej_code_parser_1.nejCodeParser(path, options));
            }
        });
    });
}
exports.getNejParseResult = getNejParseResult;
function generatorCode(statements) {
    var ast = parser.parse('');
    ast.program.body = statements;
    return generator_1["default"](ast).code;
}
exports.generatorCode = generatorCode;
function expectCodeEqual(expected, received) {
    expected = expected.trim().split('\n').map(function (line) { return line.trim(); }).filter(function (line) { return line.trim(); }).join('\n');
    received = received.trim().split('\n').map(function (line) { return line.trim(); }).filter(function (line) { return line.trim(); }).join('\n');
    expect(expected).toEqual(received);
}
exports.expectCodeEqual = expectCodeEqual;
//# sourceMappingURL=test.util.js.map