"use strict";
exports.__esModule = true;
var t = require("@babel/types");
var types_1 = require("@babel/types");
function transformThis2Window(fnBody) {
    var result = [
        // 插入 globalThis 变量指向 window
        types_1.variableDeclaration('var', [types_1.variableDeclarator(types_1.identifier('globalThis'), types_1.identifier('window'))])
    ];
    fnBody.forEach(function (statement) {
        // 转换 this 指向
        if (t.isVariableDeclaration(statement)) {
            statement.declarations.forEach(function (declaration) {
                if (t.isThisExpression(declaration.init)) {
                    declaration.init = types_1.identifier('globalThis');
                }
                else if (t.isMemberExpression(declaration.init)
                    && t.isMemberExpression(declaration.init.object)
                    && t.isThisExpression(declaration.init.object.object)) {
                    declaration.init.object.object = types_1.identifier('globalThis');
                }
            });
        }
        result.push(statement);
    });
    return result;
}
exports.transformThis2Window = transformThis2Window;
//# sourceMappingURL=transform-this-to-window.js.map