"use strict";
exports.__esModule = true;
var generator_1 = require("@babel/generator");
var parser = require("@babel/parser");
var test_util_1 = require("../test.util");
var transform_this_to_window_1 = require("./transform-this-to-window");
describe('transformThis2Window', function () {
    it('nejParser is function', function () {
        expect(transform_this_to_window_1.transformThis2Window).toBeInstanceOf(Function);
    });
    it('正确转换 global this 为 window', function () {
        var code = "\n            var self = this;\n            var _platform  = this.navigator.platform,\n                _useragent = this.navigator.userAgent;\n                \n            _pro.__reset = function(_options){\n                this.__super(_options);\n                this.__root = _options.root;\n                this.__dispatcher = _options.dispatcher;\n                this.__mpool = {}; // umi in this group\n            };\n        ";
        var ast = parser.parse(code);
        ast.program.body = transform_this_to_window_1.transformThis2Window(ast.program.body);
        test_util_1.expectCodeEqual(generator_1["default"](ast).code, "\n            var globalThis = window;\n            var self = globalThis;\n            var _platform = globalThis.navigator.platform,\n                _useragent = globalThis.navigator.userAgent;\n            \n            _pro.__reset = function (_options) {\n                this.__super(_options);\n                \n                this.__root = _options.root;\n                this.__dispatcher = _options.dispatcher;\n                this.__mpool = {}; // umi in this group\n            };\n        ");
    });
});
//# sourceMappingURL=transform-this-to-window.spec.js.map